


/**
 * 数组分组
 * @return 有返回最后一个对象  无返回 undefined
 * **/
Array.prototype.dj_groupByKey = function(key) {
  let mapper = [];
  if (this.length == 0){return  mapper}
  let targetValue = this[0][key];
  mapper.push({key:key,value:targetValue,dataSource:[]})
  this.forEach(function(value,index,array){
    if (value[key] != targetValue){
      mapper.push({key:key,value:value[key],dataSource:[]})
      targetValue = value[key];
    }
    mapper.dj_lastObject().dataSource.push(value);
  });

  for (let index = 0; index < mapper.length; index++){
    let object = mapper[index];
    object['index'] = index;
    object['count'] = mapper.length;
  }
  return mapper;
}
/**
 * 是否包含某个对象  数组中全是对象
 * @key 键
 * @value 值
 * @return 有返回最后一个对象  无返回 undefined
 * **/
Array.prototype.dj_containObjectByKeyAndValue = function(key,value) {
  return (this.map(function (item) { return item[key]; }).indexOf(value) >-1)?true:false ;
}


/**
 * 检索数组对象中某一属性值
 * @key 属性名
 * @isUnique 是否去重 默认去重
 * @return 返回一个数组
 * **/
Array.prototype.dj_checkOutObjectValuesByKey = function(key,isUnique = true) {
  let mapper = this.map(function (item) {
    return item[key];
  });
  if (isUnique == true) {
    mapper = Array.from(new Set(mapper));
  }
  return mapper
}
/**
 * 通过键值检索出对象
 * @key 键
 * @value 值
 * @return 返回一个结果对象
 * **/
Array.prototype.dj_checkOutObjectsByKeyAndValue = function(key,value) {
  let mapper = {data:[], index:[]}
  this.filter(function(item,index){
    if (item[key] == value){
      mapper.data.push(item);
      mapper.index.push(index)
    }
  })
  return mapper;
}


/**
 * 数组对象键映射
 * @key 键
 * @value 值
 * @return 返回一个结果对象
 * **/
Array.prototype.dj_objectKeyMap = function(keyMap={}) {
  const array = Object.dj_copy(this)
  for(let i = 0;i < array.length;i++){
    let obj = array[i];
    for(let key in obj){
      let newKey = keyMap[key];
      if(newKey){
        obj[newKey] = obj[key];
        delete obj[key];
      }
    }
  }
  return array;

}



