




Date.dj_timeStringToTimestamp = function(string,isMs = true){
  let timestamp = Date.parse(string.replace(/-/gi,"/"));
  if (isMs){
    return timestamp;
  }else {
    return timestamp/1000;
  }
}

Date.dj_isToday = function(string,isMs = true){
  return Date.dj_getNowTimestamp(isMs) ===  Date.dj_timeStringToTimestamp(string,isMs)
}


/**
 * 时间戳与当前时间的时间差
 * **/
Date.dj_timestampDifference = function(startTimestamp){
  if (Date.dj_isTimestamp(startTimestamp)){
    //秒级
    let endTimestamp = Date.dj_getNowTimestamp(false)
    return startTimestamp - endTimestamp
  }else if (Date.dj_isTimestamp(startTimestamp, true)){
    //毫秒级
    let endTimestamp = Date.dj_getNowTimestamp(true)
    return startTimestamp - endTimestamp
  }else {
    return 0;
  }
}

Date.dj_isTimestampNumber = function(timestamp){
  let type = Object.dj_isNumber(timestamp);
  if (type == false){
    console.warn('【DjFoundation 警告】【 方法 dj_isTimestamp --> timestamp 不是 int 类型】');
    return type;
  }else {
    type = timestamp.dj_isInt();
    if (type == false){
      console.warn('【DjFoundation 警告】【 方法 dj_isTimestamp --> timestamp 不是 int 类型】');
      return type;
    }else {
      return timestamp.dj_length() == 10 || timestamp.dj_length() == 13
    }
  }
}
Date.dj_isTimestamp = function(timestamp,isMs = false){
  let isTimestamp = Date.dj_isTimestampNumber(timestamp);
  if (isTimestamp == false){
    return false;
  }else {
    if (isMs == false){
      if (timestamp.dj_length() == 10){
        return true;
      }else {
        return false
      }
    }else {
      if (timestamp.dj_length() == 13){
        return true;
      }else {
        return false
      }
    }
  }
}


/**
 * 获取当前时间戳
 * **/
Date.dj_getNowTimestamp = function(isMs = false){
  if (isMs == true){
    return Math.round(new Date()/1);
  }else {
    return Math.round(new Date() / 1000);
  }
}
Date.dj_timestampTransitionWithFormatter = function(timestamp,formatter = 'yyyy-MM-dd hh:mm:ss'){
  let newTimestamp = timestamp;
  if (timestamp.dj_length() == 10){
    newTimestamp = timestamp * 1000
  }else if (timestamp.dj_length() == 13){}else {
    console.warn('【DjFoundation 警告】【 方法 dj_timestampTransitionWithFormatter --> timestamp 不是时间戳】'); return '';
  }
  let date = new Date(newTimestamp)
  return date.dj_transformToDateStringByFormatter(formatter)
}






Date.dj_getDateDiff = function(timeStamp){
  let arrTimeStamp = (timeStamp + '').split('');
  for (let start = 0; start < 13; start++) {
    if (!arrTimeStamp[start]) {
      arrTimeStamp[start] = '0';
    }
  }
  timeStamp = arrTimeStamp.join('') * 1;
  let minute = 1000 * 60;
  let hour = minute * 60;
  let day = hour * 24;
  let month = day * 30;
  let now = new Date().getTime();
  let diffValue = now - timeStamp;
  // 如果本地时间反而小于变量时间
  if (diffValue < 0) {
    return '不久前';
  }
  // 计算差异时间的量级
  let monthString = diffValue / month;
  let weekString = diffValue / (7 * day);
  let dayString = diffValue / day;
  let hourString = diffValue / hour;
  let minString = diffValue / minute;

  // 数值补0方法
  let zero = function (value) {
    if (value < 10) {
      return '0' + value;
    }
    return value;
  };

  // 使用
  if (monthString > 4) {
    // 超过1年，直接显示年月日
    return (function () {
      let date = new Date(timeStamp);
      return date.getFullYear() + '年' + zero(date.getMonth() + 1) + '月' + zero(date.getDate()) + '日';
    })();
  } else if (monthString >= 1) {
    return parseInt(monthString) + "月前";
  } else if (weekString >= 1) {
    return parseInt(weekString) + "周前";
  } else if (dayString >= 1) {
    return parseInt(dayString) + "天前";
  } else if (hourString >= 1) {
    return parseInt(hourString) + "小时前";
  } else if (minString >= 1) {
    return parseInt(minString) + "分钟前";
  }
  return '刚刚';
}




Date.prototype.dj_transformToDateStringByFormatter = function (formatter) {
  let object = {
    "M+": this.getMonth() + 1, //月份
    "d+": this.getDate(), //日
    "h+": this.getHours(), //小时
    "m+": this.getMinutes(), //分
    "s+": this.getSeconds(), //秒
    "q+": Math.floor((this.getMonth() + 3) / 3), //季度
    "S": this.getMilliseconds() //毫秒
  };
  if (/(y+)/.test(formatter)) formatter = formatter.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
  for (let key in object)
    if (new RegExp("(" + key + ")").test(formatter)) formatter = formatter.replace(RegExp.$1, (RegExp.$1.length == 1) ? (object[key]) : (("00" + object[key]).substr(("" + object[key]).length)));
  return formatter;
}


Date.dj_countDownStateEnum = function () {
  return {
    'DjCountDownStateBefore'       : 5 << 1,
    'DjCountDownStateCounting'     : 5 << 2,
    'DjCountDownStateEnd'          : 5 << 3,
  }
}



Date.dj_dateArray = function(length,type) {
  return Array.from({ length: length }, (_, index) => {
    let temp = ''
    switch (type.toLocaleLowerCase()) {
      case 'day':
        temp = Number(index + 1) + '日'
        break
      case 'month':
        temp = Number(index + 1) + '月'
        break
      case 'week':
        temp = '第' + Number(index + 1) + '周'
        break
      case 'weekday':
        temp = '周11' + Number(index + 1)
        break
      default:
        '20' + Number(index + 1) + '年'
        break
    }
    return temp
  })
}

Date.dj_monthArray = function() {
  let date = new Date();
  let now = date.getMonth()+1+'月';
  let d = new Date(now.replace(/[^\d]/g, "/") + "/1");
  let result = [now];
  for(let i = 0; i < 11; i++) {
    d.setMonth(d.getMonth() - 1);
    let m = d.getMonth() + 1;
    m = m < 10 ? "0" + m : m;
    result.push( m+'月');
  }
  return result.reverse();
}



Date.prototype.dj_copy = function () {
  return Object.dj_copy(this);
};
