
import './category+Number'





String.prototype.dj_check = function(type) {
  if (typeof this != 'string'){return false;}
  switch (type) {
    case 'phone':   //手机号码
      return /^1[3|4|5|6|7|8][0-9]{9}$/.test(this);
    case 'tel':     //座机
      return /^(0\d{2,3}-\d{7,8})(-\d{1,4})?$/.test(this);
    case 'card':    //身份证
      return /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test(this);
    case 'pwd':     //密码以字母开头，长度在6~18之间，只能包含字母、数字和下划线
      return /^[a-zA-Z]\w{5,17}$/.test(this)
    case 'postal':  //邮政编码
      return /[1-9]\d{5}(?!\d)/.test(this);
    case 'QQ':      //QQ号
      return /^[1-9][0-9]{4,9}$/.test(this);
    case 'email':   //邮箱
      return /^[\w-]+(\.[\w-]+)*@[\w-]+(\.[\w-]+)+$/.test(this);
    case 'money':   //金额(小数点2位)
      return /^\d*(?:\.\d{0,2})?$/.test(this);
    case 'URL':     //网址
      return /(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/.test(this)
    case 'IP':      //IP
      return /((?:(?:25[0-5]|2[0-4]\\d|[01]?\\d?\\d)\\.){3}(?:25[0-5]|2[0-4]\\d|[01]?\\d?\\d))/.test(this);
    case 'date':    //日期时间
      return /^(\d{4})\-(\d{2})\-(\d{2}) (\d{2})(?:\:\d{2}|:(\d{2}):(\d{2}))$/.test(this) || /^(\d{4})\-(\d{2})\-(\d{2})$/.test(this)
    case 'number':  //价格
      return /^[0-9]*$/.test(this);
    case 'price':  //数字
      return  /(^[1-9]\d*(\.\d{1,2})?$)|(^0(\.\d{1,2})?$)/.test(this);
    case 'english': //英文
      return /^[a-zA-Z]+$/.test(this);
    case 'chinese': //中文
      return /^[\u4E00-\u9FA5]+$/.test(this);
    case 'lower':   //小写
      return /^[a-z]+$/.test(this);
    case 'upper':   //大写
      return /^[A-Z]+$/.test(this);
    case 'HTML':    //HTML标记
      return /<("[^"]*"|'[^']*'|[^'">])*>/.test(this);
    default:
      return true;
  }
}





/** 判断是否为空  **/
String.prototype.dj_isEmpty = function() {
  if (typeof this != 'string' ) { return false; }
  if(typeof this == "undefined" || this == null || this == "" || this == "null"){
    return true;
  }else{
    return false;
  }
}
/** 判断是否为空  **/
String.prototype.dj_notEmpty = function() {
  return !this.dj_isEmpty()
}

/**
 * 把字符串分割为数组
 * **/
String.prototype.dj_componentsSeparatedByString = function(string) {
  return this.split(string);;
}





/**
 * 字符串后缀
 * **/
String.prototype.dj_suffix = function() {
  let index = this.lastIndexOf('.');
  return this.substring(index,this.length);
}
/**
 * 获取文件名
 * **/
/**
 * 获取文件名
 * **/
String.prototype.dj_getFileName = function(useExtension = false) {
  let pos1 = this.lastIndexOf('/');
  let pos2 = this.lastIndexOf('\\');
  let pos  = Math.max(pos1, pos2)
  let fileName = ''
  if( pos<0 ){
    fileName =  this;
  }else {
    fileName = this.substring(pos+1);
  }
  if (useExtension){
    return fileName;
  }else {
    return fileName.substring(0, fileName.lastIndexOf("."))
  }
}
/**
 * 手机号码加密
 * **/
String.prototype.dj_phoneEncrypt = function() {
  return  this.replace(/(\d{3})\d{4}(\d{4})/, "$1****$2")
}





/**
 * 检索出字符串中所有整数
 * **/
String.prototype.dj_integerValueArray = function() {
  return this.match(/[0-9][0-9]*/g)
}
/**
 * 检索出字符串中所有小数或者整数
 * **/
String.prototype.dj_doubleValueArray= function() {
  return this.match(/\d+(\.\d+)?/g)
}
/**
 * 转为单位
 * @unit 单位
 * @return 一个带有单位的字符串
 * **/
String.prototype.dj_unit = function(unit='px'){
  let number = this.dj_doubleValueArray().dj_firstObject();
  return number + unit;
}











String.prototype.dj_copy = function () {
  return Object.dj_copy(this);
};
