import DjObject from './DjObject'

class DjVueModel extends DjObject{
  constructor () {
    super();
    /** vue名 **/
    this.vueName = '';
    /** 每页数据量 **/
    this.pageSizes = [10,15,20,30];
    /** 当前页数 **/
    this.paginate = {page:1, pageSize:this.pageSizes[0]};
    /** 原始数据，不做任何操作，紧紧查看时使用 **/
    this.data = [];
    /** 数据源 **/
    this.dataSource = [];
    /** 数据源的子数据源的key **/
    this.dataSourceKey = '';
    /** 回调函数 **/
    this.callBackBlock = Function;
    /** 销毁回调函数 **/
    this.deallocBackBlock = Function;
    /** 请求结果回调 **/
    this.requestBlock = Function;

  }
  /**
   * 绑定参数
   * **/
  dj_bindParameter(parameter){
    let keys = Object.keys(parameter);
    keys.forEach((item)=>{
      this.paginate[item] = parameter[item];
    });
  }
  /**
   * 刷新指令
   * **/
  dj_refreshDataRequest(){}
  /**
   * 请求指令
   * **/
  dj_loadDataRequest(){
    return Object.dj_copy(this.paginate);
  }
  /**
   * 配置数据指令
   * **/
  dj_configDataHandle(data){
    this.data = Object.dj_copy(data);
  }


}
export default DjVueModel
