import DjObject from '../base/DjObject'
import { init_dictionary } from '../../class/DjDictionary'

class DjModel extends DjObject{
  constructor (data = {}) {
    super();

    this.dj_init();
    let newData = this.dj_deepCopy(data);
    if (Object.keys(newData).length>0){
      this.dj_modelWithJson(newData)
    }else {
      this.dj_customerOperation();
    }
  }

  dj_init(){
    this.id = '';

  }
  dj_objectTranspositionKeyValue (object) {
    return Object.keys(object).reduce((newData, key) => {
      let newKey = object[key] || key
      newData[newKey] = key
      return newData
    }, {})
  }
  dj_modelToJsonObject(){
    let input = {};
    input = this;
    let propertyMapper = this.dj_objectTranspositionKeyValue(this.dj_modelCustomPropertyMapper());
    let data = Object.keys(input).reduce((newData, key) => {
      let newKey = propertyMapper[key] || key
      newData[newKey] = input[key]
      return newData
    }, {})
    return data;
  }

  dj_modelWithJson(data = {}){


    if (typeof data  != 'object'){ return ; }
    let customerProperty = this.dj_modelCustomPropertyMapper();
    if (customerProperty.dj_length() == 0){ this.dj_customerOperation(); }
    let customerPropertyData = Object.keys(data).reduce((newData, key) => {
      let newKey = customerProperty[key] || key
      newData[newKey] = data[key]
      return newData
    }, {});
    let targetMapper = Object.keys(this).dj_intersectionWithOtherArray(Object.keys(customerPropertyData))
    let classesMapper = this.dj_modelContainerPropertyGenericClass();
    targetMapper.forEach((item)=> {
      if (classesMapper.dj_length() > 0){

      }else {
        this[item] = customerPropertyData[item];
      }
    });
    this.dj_customerOperation();
  }

  dj_customerOperation(){

  }

  dj_modelCustomPropertyMapper(){
    return init_dictionary();
  }
  dj_modelContainerPropertyGenericClass(){
    return init_dictionary()
  }

  dj_deepCopy(obj){
    var result = Array.isArray(obj) ? [] : {};
    for (var key in obj) {
      if (obj.hasOwnProperty(key)) {
        if (typeof obj[key] === 'object' && obj[key]!==null) {
          result[key] = this.dj_deepCopy(obj[key]);   //递归复制
        } else {
          result[key] = obj[key];
        }
      }
    }
    return result;
  }

}
export default DjModel
export function dj_modelWithJSONArray(array,modelName) {
  let modelArray = new Array();
  for (let i = 0; i < array.length; i++ ){
    let model = new modelName();
    model.dj_modelWithJson(array[i])
    modelArray.push(model);
  }
  return modelArray;
}
